import { Address, Arc, IGenesisProtocolParams, IPluginManagerProposalState, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionResultHandler } from '../../index';
export interface IPluginManagerState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
        daoFactory: Address;
    };
}
export interface IProposalCreateOptionsPM extends IProposalBaseCreateOptions {
    packageVersion: number[];
    permissions: string;
    pluginName: string;
    pluginData: string;
    pluginToReplace?: string;
}
export declare class PluginManagerPlugin extends ProposalPlugin<IPluginManagerState, IPluginManagerProposalState, IProposalCreateOptionsPM> {
    static fragment: {
        name: string;
        fragment: import("graphql").DocumentNode;
    };
    static itemMap(context: Arc, item: any, queriedId?: string): IPluginManagerState | null;
    createProposalTransaction(options: IProposalCreateOptionsPM): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
}
