import { CompetitionPlugin, CompetitionProposal, ContributionRewardExtPlugin, ContributionRewardExtProposal, ContributionRewardPlugin, ContributionRewardProposal, FundingRequest, FundingRequestProposal, GenericPlugin, GenericPluginProposal, IPluginState, IProposalBaseCreateOptions, IProposalCreateOptionsComp, IProposalCreateOptionsCR, IProposalCreateOptionsCRExt, IProposalCreateOptionsFundingRequest, IProposalCreateOptionsGS, IProposalCreateOptionsJoinAndQuit, IProposalCreateOptionsPM, IProposalCreateOptionsSR, IProposalState, JoinAndQuit, JoinAndQuitProposal, Plugin, PluginManagerPlugin, PluginManagerProposal, Proposal, ProposalPlugin, ReputationFromTokenPlugin, SchemeRegistrarPlugin, SchemeRegistrarProposal, UnknownPlugin, UnknownProposal } from '../index';
export declare const ProposalPlugins: {
    FundingRequest: typeof FundingRequest;
    JoinAndQuit: typeof JoinAndQuit;
    GenericScheme: typeof GenericPlugin;
    SchemeRegistrar: typeof SchemeRegistrarPlugin;
    ContributionReward: typeof ContributionRewardPlugin;
    ContributionRewardExt: typeof ContributionRewardExtPlugin;
    Competition: typeof CompetitionPlugin;
    SchemeFactory: typeof PluginManagerPlugin;
    Unknown: typeof UnknownPlugin;
};
export declare const Plugins: {
    ReputationFromToken: typeof ReputationFromTokenPlugin;
    Unknown: typeof UnknownPlugin;
    FundingRequest: typeof FundingRequest;
    JoinAndQuit: typeof JoinAndQuit;
    GenericScheme: typeof GenericPlugin;
    SchemeRegistrar: typeof SchemeRegistrarPlugin;
    ContributionReward: typeof ContributionRewardPlugin;
    ContributionRewardExt: typeof ContributionRewardExtPlugin;
    Competition: typeof CompetitionPlugin;
    SchemeFactory: typeof PluginManagerPlugin;
};
export declare type PluginName = keyof typeof Plugins;
export declare const Proposals: {
    GenericScheme: typeof GenericPluginProposal;
    ContributionReward: typeof ContributionRewardProposal;
    Competition: typeof CompetitionProposal;
    ContributionRewardExt: typeof ContributionRewardExtProposal;
    FundingRequest: typeof FundingRequestProposal;
    JoinAndQuit: typeof JoinAndQuitProposal;
    SchemeRegistrar: typeof SchemeRegistrarProposal;
    SchemeRegistrarAdd: typeof SchemeRegistrarProposal;
    SchemeRegistrarEdit: typeof SchemeRegistrarProposal;
    SchemeRegistrarRemove: typeof SchemeRegistrarProposal;
    SchemeFactory: typeof PluginManagerProposal;
    Unknown: typeof UnknownProposal;
};
export declare type ProposalName = keyof typeof Proposals;
export declare type ProposalCreateOptions = IProposalCreateOptionsCRExt | IProposalCreateOptionsGS | IProposalCreateOptionsSR | IProposalCreateOptionsComp | IProposalCreateOptionsCR | IProposalCreateOptionsFundingRequest | IProposalCreateOptionsJoinAndQuit | IProposalCreateOptionsPM;
export declare abstract class AnyProposal extends Proposal<IProposalState> {
}
export declare abstract class AnyPlugin extends Plugin<IPluginState> {
}
export declare abstract class AnyProposalPlugin extends ProposalPlugin<IPluginState, IProposalState, IProposalBaseCreateOptions> {
}
